diff --git a/yum.spec b/yum.spec
index abd203f..854baf3 100644
--- a/yum.spec
+++ b/yum.spec
@@ -1,24 +1,107 @@
-Summary: RPM installer/updater
+%define move_yum_conf_back 1
+%define auto_sitelib 1
+%define yum_updatesd 0
+%define disable_check 0
+%define yum_cron_systemd 1
+%define yum_makecache_systemd 1
+
+%if 0%{?rhel}
+# If we are building for RHEL ...
+
+%if 0%{?rhel} <= 6
+# rhel-6 doesn't have the systemd stuff...
+%define yum_cron_systemd 0
+%endif
+
+%if 0%{?rhel} <= 7
+# rhel-7 doesn't use systemd timers...
+%define yum_makecache_systemd 0
+%endif
+
+# END OF: If we are building for RHEL ...
+%endif
+
+
+%if 0%{?fedora}
+# If we are building for Fedora ...
+
+# we don't have this as of RHEL-7.0.
+BuildRequires: bash-completion
+
+%if 0%{?fedora} <= 18
+# yum in Fedora <= 18 doesn't use systemd unit files...
+%define yum_cron_systemd 0
+%endif
+
+%if 0%{?fedora} <= 19
+# Don't use .timer's before 20, maybe 19?
+%define yum_makecache_systemd 0
+%endif
+
+# END OF: If we are building for Fedora ...
+%endif
+
+
+%if %{auto_sitelib}
+
+%{!?python_sitelib: %define python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
+
+%else
+%define python_sitelib /usr/lib/python?.?/site-packages
+%endif
+
+# We always used /usr/lib here, even on 64bit ... so it's a bit meh.
+%define yum_pluginslib   /usr/lib/yum-plugins
+%define yum_pluginsshare /usr/share/yum-plugins
+
+# disable broken /usr/lib/rpm/brp-python-bytecompile
+%define __os_install_post %{nil}
+%define compdir %(pkg-config --variable=completionsdir bash-completion)
+%if "%{compdir}" == ""
+%define compdir "/etc/bash_completion.d"
+%endif
+
+Summary: RPM package installer/updater/manager
 Name: yum
-Version: 3.4.2
+Version: 3.4.3
 Release: 0
 License: GPLv2+
 Group: System Environment/Base
 Source: %{name}-%{version}.tar.gz
 URL: http://yum.baseurl.org/
-BuildRoot: %{_tmppath}/%{name}-%{version}root
 BuildArchitectures: noarch
 BuildRequires: python
 BuildRequires: gettext
 BuildRequires: intltool
-
+%if %{yum_makecache_systemd}
+BuildRequires: systemd-units
+%endif
+# This is really CheckRequires ...
+BuildRequires: python-nose
+BuildRequires: python >= 2.4
+BuildRequires: rpm-python, rpm >= 0:4.4.2
+BuildRequires: python-iniparse
+BuildRequires: python-sqlite
+BuildRequires: python-urlgrabber >= 3.9.0-8
+BuildRequires: yum-metadata-parser >= 1.1.0
+BuildRequires: pygpgme
+# End of CheckRequires
+Conflicts: pirut < 1.1.4
 Requires: python >= 2.4
 Requires: rpm-python, rpm >= 0:4.4.2
+Requires: python-iniparse
 Requires: python-sqlite
-Requires: urlgrabber >= 3.9.2
+Requires: python-urlgrabber >= 3.9.0-8
 Requires: yum-metadata-parser >= 1.1.0
-Requires: python-iniparse
 Requires: pygpgme
+# rawhide is >= 0.5.3-7.fc18 ... as this is added.
+Requires: pyliblzma
+# Not really a suggests anymore, due to metadata using it.
+Requires: pyxattr
+# Suggests, needed for yum fs diff
+Requires: diffutils
+Requires: cpio
+
 Conflicts: rpm >= 5-0
 # Zif is a re-implementation of yum in C, however:
 #
@@ -34,18 +117,32 @@ Conflicts: rpm >= 5-0
 # zif experts).
 #
 # ...so we have two sane choices: i) Conflict with it. 2) Stop developing yum.
-Conflicts: zif
+#
+#  Upstream says that #2 will no longer be true after this release.
+Conflicts: zif <= 0.1.3-3.fc15
+
 Obsoletes: yum-skip-broken <= 1.1.18
+Provides: yum-skip-broken = 1.1.18.yum
 Obsoletes: yum-basearchonly <= 1.1.9
+Obsoletes: yum-plugin-basearchonly <= 1.1.9
+Provides: yum-basearchonly = 1.1.9.yum
+Provides: yum-plugin-basearchonly = 1.1.9.yum
 Obsoletes: yum-allow-downgrade < 1.1.20-0
 Obsoletes: yum-plugin-allow-downgrade < 1.1.22-0
+Provides: yum-allow-downgrade = 1.1.20-0.yum
+Provides: yum-plugin-allow-downgrade = 1.1.22-0.yum
 Obsoletes: yum-plugin-protect-packages < 1.1.27-0
-Provides: yum-skip-broken
-Provides: yum-basearchonly
-Provides: yum-allow-downgrade
-Provides: yum-plugin-allow-downgrade
-Provides: yum-protect-packages
-Provides: yum-plugin-protect-packages
+Provides: yum-protect-packages = 1.1.27-0.yum
+Provides: yum-plugin-protect-packages = 1.1.27-0.yum
+Obsoletes: yum-plugin-download-order <= 0.2-2
+Obsoletes: yum-plugin-downloadonly <= 1.1.31-7.fc18
+Provides: yum-plugin-downloadonly = 3.4.3-44.yum
+Obsoletes: yum-presto < 3.4.3-66.yum
+Provides: yum-presto = 3.4.3-66.yum
+Obsoletes: yum-plugin-security < 1.1.32
+Provides: yum-plugin-security = 3.4.3-84.yum
+BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
+
 
 %description
 Yum is a utility that can check for and automatically download and
@@ -58,9 +155,11 @@ Group: Applications/System
 Requires: yum = %{version}-%{release}
 Requires: dbus-python
 Requires: pygobject2
-Requires(preun): /sbin/chkconfig 
+Requires(preun): /sbin/chkconfig
+Requires(post): /sbin/chkconfig
 Requires(preun): /sbin/service
-Requires(postun): /sbin/chkconfig 
+Requires(post): /sbin/service
+Requires(postun): /sbin/chkconfig
 Requires(postun): /sbin/service
 
 
@@ -68,20 +167,69 @@ Requires(postun): /sbin/service
 yum-updatesd provides a daemon which checks for available updates and 
 can notify you when they are available via email, syslog or dbus. 
 
-
 %package cron
-Summary: Files needed to run yum updates as a cron job
+Summary: RPM package installer/updater/manager cron service
 Group: System Environment/Base
-Requires: yum >= 3.0 vixie-cron crontabs yum-plugin-downloadonly findutils
+Requires: yum >= 3.4.3-84 cronie crontabs findutils
+Requires: yum-cron-BE = %{version}-%{release}
+# We'd probably like a suggests for yum-cron-daily here.
+%if %{yum_cron_systemd}
+BuildRequires: systemd-units
+Requires(post): systemd
+Requires(preun): systemd
+Requires(postun): systemd
+%else
 Requires(post): /sbin/chkconfig
 Requires(post): /sbin/service
 Requires(preun): /sbin/chkconfig
 Requires(preun): /sbin/service
 Requires(postun): /sbin/service
+%endif
 
 %description cron
-These are the files needed to run yum updates as a cron job.
-Install this package if you want auto yum updates nightly via cron.
+These are the files needed to run any of the yum-cron update services.
+
+%package cron-daily
+Summary: Files needed to run yum updates as a daily cron job
+Group: System Environment/Base
+Provides: yum-cron-BE = %{version}-%{release}
+Requires: yum-cron > 3.4.3-131
+
+%description cron-daily
+This is the configuration file for the daily yum-cron update service, which
+lives %{_sysconfdir}/yum/yum-cron.conf.
+Install this package if you want auto yum updates nightly via cron (or something
+else, via. changing the configuration).
+By default this just downloads updates and does not apply them.
+
+%package cron-hourly
+Summary: Files needed to run yum updates as an hourly cron job
+Group: System Environment/Base
+Provides: yum-cron-BE = %{version}-%{release}
+Requires: yum-cron > 3.4.3-131
+
+%description cron-hourly
+This is the configuration file for the daily yum-cron update service, which
+lives %{_sysconfdir}/yum/yum-cron-hourly.conf.
+Install this package if you want automatic yum metadata updates hourly via
+cron (or something else, via. changing the configuration).
+
+%package cron-security
+Summary: Files needed to run security yum updates as once a day
+Group: System Environment/Base
+Provides: yum-cron-BE = %{version}-%{release}
+Requires: yum-cron > 3.4.3-131
+
+%description cron-security
+This is the configuration file for the security yum-cron update service, which
+lives here: %{_sysconfdir}/yum/yum-cron-security.conf
+Install this package if you want automatic yum security updates once a day
+via. cron (or something else, via. changing the configuration -- this will be
+confusing if it's not security updates anymore though).
+By default this will download and _apply_ the security updates, unlike
+yum-cron-daily which will just download all updates by default.
+This runs after yum-cron-daily, if that is installed.
+
 
 %prep
 %setup -q
@@ -89,12 +237,46 @@ Install this package if you want auto yum updates nightly via cron.
 %build
 make
 
+%if !%{disable_check}
+%check
+make check
+%endif
+
 
 %install
 [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
-make DESTDIR=$RPM_BUILD_ROOT install
-# install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/yum/yum.conf
-# install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/cron.daily/yum.cron
+
+%if %{yum_cron_systemd}
+INIT=systemd
+%else
+INIT=sysv
+%endif
+
+make DESTDIR=$RPM_BUILD_ROOT UNITDIR=%{_unitdir} INIT=$INIT install
+
+install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/yum.conf
+mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/yum/pluginconf.d $RPM_BUILD_ROOT/%{yum_pluginslib}
+mkdir -p $RPM_BUILD_ROOT/%{yum_pluginsshare}
+
+%if %{move_yum_conf_back}
+# for now, move repodir/yum.conf back
+mv $RPM_BUILD_ROOT/%{_sysconfdir}/yum/repos.d $RPM_BUILD_ROOT/%{_sysconfdir}/yum.repos.d
+rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/yum/yum.conf
+%endif
+
+%if %{yum_updatesd}
+echo Keeping local yum-updatesd
+%else
+
+# yum-updatesd has moved to the separate source version
+rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/yum/yum-updatesd.conf 
+rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/yum-updatesd
+rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/dbus-1/system.d/yum-updatesd.conf
+rm -f $RPM_BUILD_ROOT/%{_sbindir}/yum-updatesd
+rm -f $RPM_BUILD_ROOT/%{_mandir}/man*/yum-updatesd*
+rm -f $RPM_BUILD_ROOT/%{_datadir}/yum-cli/yumupd.py*
+
+%endif
 
 # Ghost files:
 mkdir -p $RPM_BUILD_ROOT/var/lib/yum/history
@@ -102,12 +284,31 @@ mkdir -p $RPM_BUILD_ROOT/var/lib/yum/plugins
 mkdir -p $RPM_BUILD_ROOT/var/lib/yum/yumdb
 touch $RPM_BUILD_ROOT/var/lib/yum/uuid
 
+# rpmlint bogus stuff...
+chmod +x $RPM_BUILD_ROOT/%{_datadir}/yum-cli/*.py
+chmod +x $RPM_BUILD_ROOT/%{python_sitelib}/yum/*.py
+chmod +x $RPM_BUILD_ROOT/%{python_sitelib}/rpmUtils/*.py
+
 %find_lang %name
 
+%if %{yum_cron_systemd}
+# Remove the yum-cron sysV stuff to make rpmbuild happy..
+rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/yum-cron
+%else
+# Remove the yum-cron systemd stuff to make rpmbuild happy..
+rm -f $RPM_BUILD_ROOT/%{_unitdir}/yum-cron.service
+%endif
+
+%if %{yum_makecache_systemd}
+cp -a etc/yum-makecache.service $RPM_BUILD_ROOT/%{_unitdir}
+cp -a etc/yum-makecache.timer   $RPM_BUILD_ROOT/%{_unitdir}
+%endif
+
 %clean
 [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
 
 
+%if %{yum_updatesd}
 %post updatesd
 /sbin/chkconfig --add yum-updatesd
 /sbin/service yum-updatesd condrestart >/dev/null 2>&1
@@ -119,9 +320,29 @@ if [ $1 = 0 ]; then
  /sbin/service yum-updatesd stop >/dev/null 2>&1
 fi
 exit 0
-
+%endif
 
 %post cron
+
+%if %{yum_cron_systemd}
+#systemd_post yum-cron.service
+#  Do this manually because it's a fake service for a cronjob, and cronjobs
+# are default on atm. This may change in the future.
+if [ $1 = 1 ]; then
+ systemctl enable yum-cron >/dev/null 2>&1
+else
+#  Note that systemctl preset is being run here ... but _only_ on initial
+# install. So try this...
+
+if [ -f /var/lock/subsys/yum-cron -a -f /etc/rc.d/init.d/yum-cron ]; then
+ systemctl enable yum-cron >/dev/null 2>&1
+fi
+fi
+
+# Also note:
+#  systemctl list-unit-files | fgrep yum-cron
+%else
+# SYSV init post cron
 # Make sure chkconfig knows about the service
 /sbin/chkconfig --add yum-cron
 # if an upgrade:
@@ -144,8 +365,13 @@ if [ "$1" -ge "1" ]; then
  fi
 fi 
 exit 0
+%endif
 
 %preun cron
+%if %{yum_cron_systemd}
+%systemd_preun yum-cron.service
+%else
+# SYSV init preun cron
 # if this will be a complete removeal of yum-cron rather than an upgrade,
 # remove the service from chkconfig control
 if [ $1 = 0 ]; then
@@ -153,33 +379,59 @@ if [ $1 = 0 ]; then
  /sbin/service yum-cron stop 1> /dev/null 2>&1
 fi
 exit 0
+%endif
 
 %postun cron
+%if %{yum_cron_systemd}
+%systemd_postun_with_restart yum-cron.service
+%else
+# SYSV init postun cron
+
 # If there's a yum-cron package left after uninstalling one, do a
 # conditional restart of the service
 if [ "$1" -ge "1" ]; then
  /sbin/service yum-cron condrestart 1> /dev/null 2>&1
 fi
 exit 0
+%endif
 
+%if %{yum_makecache_systemd}
+%post
+%systemd_post yum-makecache.timer
 
+%preun
+%systemd_preun yum-makecache.timer
+
+%postun
+%systemd_postun_with_restart yum-makecache.timer
+%endif
 
 %files -f %{name}.lang
-%defattr(-, root, root)
-%doc README AUTHORS COPYING TODO INSTALL ChangeLog PLUGINS
+%defattr(-, root, root, -)
+%doc README AUTHORS COPYING TODO ChangeLog PLUGINS
+%if %{move_yum_conf_back}
+%config(noreplace) %{_sysconfdir}/yum.conf
+%dir %{_sysconfdir}/yum.repos.d
+%else
 %config(noreplace) %{_sysconfdir}/yum/yum.conf
+%dir %{_sysconfdir}/yum/repos.d
+%endif
 %config(noreplace) %{_sysconfdir}/yum/version-groups.conf
 %dir %{_sysconfdir}/yum
 %dir %{_sysconfdir}/yum/protected.d
-%dir %{_sysconfdir}/yum/repos.d
+%dir %{_sysconfdir}/yum/fssnap.d
 %dir %{_sysconfdir}/yum/vars
-%config %{_sysconfdir}/logrotate.d/%{name}
-%{_sysconfdir}/bash_completion.d
+%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
+%(dirname %{compdir})
+%dir %{_datadir}/yum-cli
 %{_datadir}/yum-cli/*
+%exclude %{_datadir}/yum-cli/completion-helper.py?
+%if %{yum_updatesd}
 %exclude %{_datadir}/yum-cli/yumupd.py*
+%endif
 %{_bindir}/yum
-/usr/lib/python?.?/site-packages/yum
-/usr/lib/python?.?/site-packages/rpmUtils
+%{python_sitelib}/yum
+%{python_sitelib}/rpmUtils
 %dir /var/cache/yum
 %dir /var/lib/yum
 %ghost /var/lib/yum/uuid
@@ -188,20 +440,46 @@ exit 0
 %ghost /var/lib/yum/yumdb
 %{_mandir}/man*/yum.*
 %{_mandir}/man*/yum-shell*
-
+# plugin stuff
+%dir %{_sysconfdir}/yum/pluginconf.d 
+%dir %{yum_pluginslib}
+%dir %{yum_pluginsshare}
+%if %{yum_makecache_systemd}
+%{_unitdir}/yum-makecache.service
+%{_unitdir}/yum-makecache.timer
+%endif
 
 %files cron
 %defattr(-,root,root)
 %doc COPYING
-%{_sysconfdir}/cron.daily/0yum.cron
-%config(noreplace) %{_sysconfdir}/yum/yum-daily.yum
-%config(noreplace) %{_sysconfdir}/yum/yum-weekly.yum
+%{_sysconfdir}/cron.daily/0yum-daily.cron
+%{_sysconfdir}/cron.hourly/0yum-hourly.cron
+%config(noreplace) %{_sysconfdir}/yum/yum-cron.conf
+%config(noreplace) %{_sysconfdir}/yum/yum-cron-hourly.conf
+%if %{yum_cron_systemd}
+%{_unitdir}/yum-cron.service
+%else
 %{_sysconfdir}/rc.d/init.d/yum-cron
-%config(noreplace) %{_sysconfdir}/sysconfig/yum-cron
+%endif
+%{_sbindir}/yum-cron
+%{_mandir}/man*/yum-cron.*
 
+%files cron-daily
+%defattr(-,root,root)
+%{_sysconfdir}/cron.daily/0yum-daily.cron
+%config(noreplace) %{_sysconfdir}/yum/yum-cron.conf
 
+%files cron-hourly
+%defattr(-,root,root)
+%{_sysconfdir}/cron.hourly/0yum-hourly.cron
+%config(noreplace) %{_sysconfdir}/yum/yum-cron-hourly.conf
 
+%files cron-security
+%defattr(-,root,root)
+%{_sysconfdir}/cron.daily/0yum-security.cron
+%config(noreplace) %{_sysconfdir}/yum/yum-cron-security.conf
 
+%if %{yum_updatesd}
 %files updatesd
 %defattr(-, root, root)
 %config(noreplace) %{_sysconfdir}/yum/yum-updatesd.conf
@@ -210,8 +488,12 @@ exit 0
 %{_datadir}/yum-cli/yumupd.py*
 %{_sbindir}/yum-updatesd
 %{_mandir}/man*/yum-updatesd*
+%endif
 
 %changelog
+* Thu Jul 28 2011 Matthew Miller <mattdm at mattdm.org>
+- reorganize yum-cron to allow more flexible scheduling
+
 * Wed Apr 20 2011 James Antill <james at fedoraproject.org>
 - 3.4.1
 - umask bug fix.
diff --git a/yum/Errors.py b/yum/Errors.py
index c1af4ad..f69c061 100644
--- a/yum/Errors.py
+++ b/yum/Errors.py
@@ -18,7 +18,7 @@
 Exceptions and Errors thrown by yum.
 """
 
-from i18n import to_unicode
+from i18n import to_unicode, to_utf8
 
 class YumBaseError(Exception):
     """
@@ -29,7 +29,7 @@ class YumBaseError(Exception):
         Exception.__init__(self)
         self.value = value
     def __str__(self):
-        return "%s" %(self.value,)
+        return "%s" % to_utf8(self.value)
 
     def __unicode__(self):
         return '%s' % to_unicode(self.value)
@@ -74,14 +74,32 @@ class DepError(YumBaseError):
     pass
     
 class RepoError(YumBaseError):
-    pass
+    def __init__(self, value=None, repo=None):
+        Exception.__init__(self)
+        self.value = value
+        if repo is not None:
+            self.repo = repo
 
 class DuplicateRepoError(RepoError):
     pass
 
+# Have our own custom .value with all the mirror errors.
 class NoMoreMirrorsRepoError(RepoError):
-    pass
-    
+    # Weird backcompat. on argument ordering.
+    def __init__(self, value=None, errors=None, repo=None):
+        Exception.__init__(self)
+        self._value = value
+        self.errors = errors
+        if repo is not None:
+            self.repo = repo
+
+    @property
+    def value(self):
+        ret = self._value
+        for url, msg in self.errors or []:
+            ret += '\n%s: %s' % (url, msg)
+        return ret
+
 class ConfigError(YumBaseError):
     pass
     
@@ -94,6 +112,9 @@ class GroupsError(YumBaseError):
 class InstallError(YumBaseError):
     pass
 
+class GroupInstallError(InstallError):
+    pass
+
 class UpdateError(YumBaseError):
     pass
     
